/*
	MemoCgi.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: May 1, 2000
	Class	: Software Engineering Lab
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 6.0 & gcc 2.7.2
	Tab Size: 8
	
	Copyright (c) 2000, Kang Jul Ki
*/

#ifndef _Memo_Cgi_h_
#define _Memo_Cgi_h_

#include <stdio.h>

#define	TRUE			(1)
#define	FALSE			(0)

#define	MEMO			10
#define	GONGJI			20

#define	ALLOW			1
#define	DENY			0

#define	MAX_STR_LEN		255
#define	MAX_PASSWD_LEN		20

#define	BUILD_INFO		"1.1.9"

/**
 * Infomation for Sys Configuration.
*/
typedef struct tagSysConfig
{
	int	iTotalCount;
	int	iTodayCount;
	char*	pszInitDate;

	int	iLastNum;
	int	iWidth;
	int	iArticlePerPage;
	int	iIsPostAllow;	
	char*	pszAd;		
	char*	pszPasswd;
} SysConfig;

typedef struct tagDb
{
	char*	pDbName;
	char*	pDbMode;

	int	iPage;
	int	iNum;
} Db;

/**
 *  Database Ǵ κ.
*/
typedef struct tagDbArticle
{
	int	iNum;
	int	iAccess;
	int	iThread;
	char*	pszDate;
	char*	pszTime;

	char*	pszName;
	char*	pszEMail;
	char*	pszPasswd;
	char*	pszTitle;
	char*	pszIpAdd;
} DbArticle;

typedef struct tagDbList
{
	int	iNum;		// ȣ
	int	iAccess;	// Ƚ

	char*	pszName;	// ̸
	char*	pszEMail;	// EMail
	char*	pszTitle;	// 
	char*	pszIpAdd;	// IP Address
	char*	pszDate;	// ¥
	char*	pszTime;	// ð
} DbList;


/**
 * Index Struct for Making a Index in the Info_Board.cpp
*/
typedef struct tagD_INDEX
{
	int	num;
	int	thread;
} D_INDEX;

typedef struct tagT_INDEX
{
	int	num;
	int	depth;
} T_INDEX;

#define	STACK_SIZE	(100)

typedef struct tagINDEX_STACK
{
	int	num1[STACK_SIZE+1];
	int	num2[STACK_SIZE+1];
} INDEX_STACK;

#endif



/*******************

@2000/05/18/20:00 - Version 1.1.0
 * MemoWrite.cpp ۻ ߰

@2000/05/19/15:00 - Version 1.1.5
 * MemoBoard.cpp input box  ߰

@2000/05/19/15:00 - Version 1.1.6
 * MemoMain.cpp Refresh   ߰

@2000/05/19/15:00 - Version 1.1.7
 *   ߰

@2000/05/31/12:00 - Version 1.1.8
 *   

@2000/06/06/23:00 - Version 1.1.9
 * Makefile 
 * Unix/Linux/Win32 ...

*/
