/*
	JkMemoBoard.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: May 1, 2000
	Class	: Software Engineering Lab
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 6.0 & gcc 2.7.2
	Tab Size: 8
	
	Copyright (c) 2000, Kang Jul Ki
*/

#ifndef _JkMemoBoard_h_
#define _JkMemoBoard_h_

#include "qDecoder.h"
#include "JkMemo.h"
#include "JkMemoMain.h"
#include <time.h>
#include <string.h>

/**
 * This class is used for Main Board.
 */
class JkMemoBoard
{
	JkMemoMain*	m_pJkMemoMain;
	DbArticle*	m_pDbArticle;

	D_INDEX*	dIndex;
	T_INDEX*	tIndex;

	INDEX_STACK	stack;
	int		sp;
	int		m_iTotalArticle;

public:
	JkMemoBoard	(JkMemoMain* pInfoMain);
	~JkMemoBoard	();

	int	GetTotalArticle	() {	return	m_iTotalArticle;	}

	void	ShowList	();

	int	MainIndex	();
	void	PrintIndex	(int iTotal);
	int	GetIndex	(int iNum);
	void	AdjustIndex	();
	void	DateIndex	();
	void	ThreadIndex	();

	int	FindThread	(int iNum, int iUpper);
	int	InsertIndex	(int iNum, int iDepth);
	int	PushIndex	(int iNum, int i);
	int	PopIndex	(int *iNum, int *i);

	int	GetArticleInfo	(int iNum, DbList* head);
	void	FreeArticleInfo (DbList* head);

	void	Run		();
};

#endif // _JkMemoBoard_h_
