/*
	JkMemoMain.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: May 1, 2000
	Class	: Software Engineering Lab
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 6.0 & gcc 2.7.2
	Tab Size: 8
	
	Copyright (c) 2000, Kang Jul Ki
*/

#ifndef _JkMemoMain_h_
#define _JkMemoMain_h_

#include "qDecoder.h"
#include "gdbm.h"
#include "JkMemo.h"
#include "cwb_db.h"
#include <time.h>
#include <string.h>

/**
 * This class is used for Main Routine.
 */
class JkMemoMain
{
	clock_t	runTime;
	int	m_iRefreshValue;

public:
	Db*		m_pDb;
	SysConfig*	m_pSysConfig;
	char		m_szDate[10+1];
	char		m_szTime[5+1];
	char*		m_pszIpAdd;

	JkMemoMain	();
	~JkMemoMain	();

	void	GetSysConfig	();
	void	GetDbConfig	();

	char*	GetDate() 	{ return	m_szDate;	}
	char*	GetTime() 	{ return	m_szTime;	}
	char*	GetIpAdd() const	{ return	m_pszIpAdd;	}

	int	GetTotalCount() const	{ return	m_pSysConfig->iTotalCount; }
	int	GetTodayCount() const	{ return	m_pSysConfig->iTodayCount; }
	char*	GetInitDate() const	{ return	m_pSysConfig->pszInitDate; }
	int	GetLastNum() const	{ return	m_pSysConfig->iLastNum; }
	int	GetWidth() const	{ return	m_pSysConfig->iWidth;	}
	int	GetArticlePerPage() const { return	m_pSysConfig->iArticlePerPage; }
	int	IsPostAllow() const	  { return	m_pSysConfig->iIsPostAllow;	}
	char*	GetAd() const		{ return	m_pSysConfig->pszAd;	 }
	char*	GetAdminPasswd() const	{ return	m_pSysConfig->pszPasswd; }

	char*	GetDbName() const	{ return	m_pDb->pDbName; }
	char*	GetDbMode() const	{ return	m_pDb->pDbMode; }
	int	GetPageNum() const	{ return	m_pDb->iPage;	}
	int	GetDbNum()	{ return	m_pDb->iNum;	}

	void	HeadHtml	(char* szTitle = "");
	void	TailHtml	(void);
	void	RefreshList	(void);
	void	SetRefreshValue (int iRefresh = 300)	{ m_iRefreshValue = iRefresh;	}
	int	GetRefreshValue	(void)			{ return	m_iRefreshValue; }

	void	ProgramInfo	(void);
	char*	GetBuildInfo	(void) const	{	return	BUILD_INFO;	};

	void	Run(void);
};

#endif	// _JkMemoMain_h_
