/*
	JkMemoWrite.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: May 1, 2000
	Class	: Software Engineering Lab
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 6.0 & gcc 2.7.2
	Tab Size: 8
	
	Copyright (c) 2000, Kang Jul Ki
*/

#include "JkMemoMain.h"
#include "JkMemoWrite.h"
#include <stdlib.h>

#if defined(UNIX)
#include <crypt.h>
#else
#include "JkCrypt.h"
#endif

/**
 * Construtor.
 */
JkMemoWrite::JkMemoWrite(JkMemoMain* pJkMemoMain)
{
	m_pJkMemoMain = pJkMemoMain;
	m_pDbArticle = new DbArticle;
}

/**
 * Destructor.
 */
JkMemoWrite::~JkMemoWrite()
{
	delete m_pDbArticle;
}

/**
 * Save DB into GDBM.
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::WriteSave(void)
{
	char	szPath[0xff] = "";
	char	szBuf[0xff] = "";
	char*	pszEmail = NULL;

	pszEmail = qValue("EMail");

	if (strcmp(pszEmail, "E-Mail") == 0)
	{
		strcpy(pszEmail, "");
	}

	/**
	 * Check if Input is OK.
	*/
	if (strcmp(qValue("Name"), "") == 0 || strcmp(qValue("Name"), "̸") == 0)
	{
		qError("̸ ݵ Էؾ߸ մϴ.");
	}
	if (strcmp(pszEmail, "") != 0)
	{
		/**
		 * E-Mail ּ  ˻Ѵ.
		 * 1 : Ok, 0 : Error
		*/
		if (qCheckEmail(pszEmail) == 0)
		{
			qError("E-Mail ּ ٸ.");
		}
	}
	if (strcmp(qValue("Title"), "") == 0 || strcmp(qValue("Title"), "޼ Էϼ") == 0)
	{
		qError("޼ ݵ Էؾ߸ մϴ.");
	}

	/**
	 * Get qValue
	*/
	sprintf(szPath, "./db/%s.gdbm", m_pJkMemoMain->GetDbName());
	DBOpen(szPath, GDBM_WRITER);

	/**
	 * Get the last number
	*/
	m_pJkMemoMain->m_pSysConfig->iLastNum = DBiFetch("SysConfig.iLastNum");
	m_pJkMemoMain->m_pSysConfig->iLastNum++;

	/**
	 * Store iLastNum
	*/
	DBiStore("SysConfig.iLastNum", m_pJkMemoMain->GetLastNum(), GDBM_REPLACE);

	sprintf(szBuf, "%d.iNum", m_pJkMemoMain->GetLastNum());
	DBiStore(szBuf, m_pJkMemoMain->GetLastNum(), GDBM_REPLACE);

	sprintf(szBuf, "%d.iAccess", m_pJkMemoMain->GetLastNum());
	DBiStore(szBuf, 0, GDBM_REPLACE);

	sprintf(szBuf, "%d.iThread", m_pJkMemoMain->GetLastNum());
	DBiStore(szBuf, 0, GDBM_REPLACE);

	sprintf(szBuf, "%d.pszDate", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, m_pJkMemoMain->GetDate(), GDBM_REPLACE);

	sprintf(szBuf, "%d.pszTime", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, m_pJkMemoMain->GetTime(), GDBM_REPLACE);

	sprintf(szBuf, "%d.pszName", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, qValue("Name"), GDBM_REPLACE);

	sprintf(szBuf, "%d.pszEMail", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, pszEmail, GDBM_REPLACE);

	sprintf(szBuf, "%d.pszIpAdd", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, m_pJkMemoMain->GetIpAdd(), GDBM_REPLACE);

	sprintf(szBuf, "%d.pszTitle", m_pJkMemoMain->GetLastNum());
	DBStore(szBuf, qValue("Title"), GDBM_REPLACE);

	DBClose();
}

/**
 * Show Admin Login
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::AdminLogin(void)
{
	m_pJkMemoMain->SetRefreshValue(300);
	m_pJkMemoMain->HeadHtml(" α");

	printf("<script name='JavaScript'>\n");
	printf("  function checkForm()\n");
	printf("  {\n");
	printf("    var form = document.forms[0];\n");
	printf("    if (IsEmpty(form.passwd.value)) {\n");
	printf("      alert(\"ȣ Էؾ߸ մϴ.\");\n");
	printf("      form.passwd.focus();\n");
	printf("      return false;\n");
	printf("    }\n");
	printf("  }\n");
	printf("  function IsEmpty(val) {\n");
	printf("    for (var i=0; i<val.length; i++) {\n");
	printf("      if (val.substring(i,i+1) != \" \")\n");
	printf("        return false;\n");
	printf("    }\n");
	printf("    return true;\n");
	printf("  }\n");
	printf("</script>\n\n");
	
	printf("<br><br><br><br><br>\n");

	printf("<form method=post action='%s' onSubmit=\"return checkForm()\">\n", qCGIname());
	printf("<table border=0 cellpadding=1 cellspacing=0 bgcolor=black width=300>\n");
	printf("  <tr>\n");
	printf("    <td>\n");
	printf("    <table border=0 cellpadding=1 cellspaciing=0 bgcolor=white width='100%%'>\n");
	printf("      <input type=hidden name=dbName value='%s'>\n", m_pJkMemoMain->GetDbName());
	printf("      <input type=hidden name=dbMode value='AdminForm'>\n");
	printf("      <tr height=24 bgcolor=#2b3856>\n");
	printf("        <td colspan=2 align=middle><b><font size=3 color=white> α</font></b></td>\n");
	printf("      </tr>\n");
	printf("      <tr><td colspan=2>&nbsp;</td></tr>\n");
	printf("      <tr>\n");
	printf("        <td align=center width=50%%> ȣ&nbsp;&nbsp;</td>\n");
	printf("        <td align=left>\n");
	printf("          <input type=password name=passwd size=10 maxlength=8 class=editbox>\n");
	printf("          <script language='JavaScript'>\n");
	printf("            <!--\n");
	printf("              document.forms[0].passwd.focus();\n");
	printf("            -->\n");
	printf("          </script>\n");
	printf("        </td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2>&nbsp;</td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2 align=middle>\n");
	printf("          <input type=submit value='            ' class=button>\n");
	printf("        </td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2>&nbsp;</td>\n");
	printf("      </tr>\n");
	printf("    </table>\n");
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("</table>\n");
	printf("</form>\n");

	m_pJkMemoMain->TailHtml();
}


/**
 * Show Admin Form
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::AdminForm(void)
{
	char	szPath[0xff] = "";

	/**
	 * Get DB File
	*/
	sprintf(szPath, "./db/%s.gdbm", m_pJkMemoMain->GetDbName());

	DBOpen(szPath, GDBM_READER);

	m_pJkMemoMain->m_pSysConfig->pszPasswd = DBFetch("SysConfig.pszPasswd");

	m_pJkMemoMain->SetRefreshValue(300);
	m_pJkMemoMain->HeadHtml(" ȯ漳");

	printf("<script language='JavaScript'>\n");
	printf("  function OnEnter(field) {\n");
	printf("     field.className = 'fo';\n");
	printf("     if (field.value == field.defaultValue) {\n");
	printf("        field.value = '';\n");
	printf("     }\n");
	printf("  }\n\n");
	printf("  function OnExit(field) {\n");
	printf("     field.className = 'bl';\n");
	printf("     if (field.value == '') {\n");
	printf("        field.value = field.defaultValue;\n");
	printf("     }\n");
	printf("  }\n\n");
	printf("</script>\n\n");

#if defined(UNIX)
	if (strcmp(crypt(qValue("passwd"), "jk"), m_pJkMemoMain->GetAdminPasswd()) != 0)
#else
	if (strcmp(jk_crypt(qValue("passwd"), "jk"), m_pJkMemoMain->GetAdminPasswd()) != 0)
#endif

	{
		qError("н尡 Ʋϴ.");
	}

	printf("<font size=4><b> ȯ漳</b></font>\n\n");
	printf("<br><br><br>\n");

	printf("<form method=post action='%s'>\n", qCGIname());
	printf("<table border=0 cellpadding=0 cellspacing=1 bgcolor=black width='%d'>\n", m_pJkMemoMain->GetWidth());
	printf("  <tr bgcolor='#ffffff'>\n");
	printf("    <td>\n");
	printf("      <table border=0 cellpadding=1 cellspacing=1 bgcolor='#ffffff' width='100%%'>\n");
	printf("        <input type=hidden name=dbName value='%s'>\n", m_pJkMemoMain->GetDbName());
	printf("        <input type=hidden name=dbMode value='AdminSave'>\n");
	printf("        <tr>\n");
	printf("          <td align=right bgcolor='#78747d'><font color='#ffffff' onblur='OnExit(this) onfocus='OnEnter(this)'>ο ȣ</font></td>\n");
	printf("          <td bgcolor='#dde4cf'>\n");
	printf("            <input type=password name=passwd1 maxlength=8 size=10 onblur='OnExit(this)' onfocus='OnEnter(this)' class=editbox> &nbsp;&nbsp;&nbsp;\n");
	printf("            <script language='JavaScript'>\n");
	printf("              <!--\n");
	printf("                document.forms[0].passwd1.focus();\n");
	printf("              -->\n");
	printf("            </script>\n");
	printf("            ѹ\n");
	printf("            <input type=password name=passwd2 maxlength=8 size=10 onblur='OnExit(this)' onfocus='OnEnter(this)' class=editbox>\n");
	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr>\n");
	printf("          <td align=right bgcolor='#787473'><font color='#ffffff'> </font></td>\n");
	printf("          <td bgcolor='#dde4cf'>\n");
	printf("            <input type=text name=ad maxlength=100 size=48 value='%s' class=editbox onblur='OnExit(this)' onfocus='OnEnter(this)'>\n", DBFetch("SysConfig.pszAd"));
	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr>\n");
	printf("          <td align=right bgcolor='#787473'><font color='#ffffff'>̺ </font></td>\n");
	printf("          <td bgcolor='#dde4cf'>\n");	
	printf("            <input type=text name=width maxlength=5 size=5 value='%d' onblur='OnExit(this)' onfocus='OnEnter(this)' class=editbox> pixel\n", DBiFetch("SysConfig.iWidth"));
	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr>\n");
	printf("          <td align=right bgcolor='#787473'><font color='#ffffff'>/</font></td>\n");
	printf("          <td bgcolor='#dde4cf'>\n");	
	printf("            <input type=text name=ArticlePerPage maxlength=2 size=5 value='%d' onblur='OnExit(this)' onfocus='OnEnter(this)' class=editbox>  (15 )\n", DBiFetch("SysConfig.iArticlePerPage"));
	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr>\n");
	printf("          <td align=right bgcolor='#787473'><font color='#ffffff'></font></td>\n");
	printf("          <td bgcolor='#dde4cf'>\n");

	if (m_pJkMemoMain->IsPostAllow() == ALLOW)
	{
		printf("            <input type=radio name=posting value='allow' checked>\n");
		printf("            <input type=radio name=posting value='deny'>\n");
	}
	else
	{
		printf("            <input type=radio name=posting value='allow'>\n");
		printf("            <input type=radio name=posting value='deny' checked>\n");
	}

	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr><td colspan=2>&nbsp;</td></tr>\n");
	printf("        <tr>\n");
	printf("          <td align=center colspan=2>\n");
	printf("            <input type=submit value='            ' class=button>\n");
	printf("          </td>\n");
	printf("        </tr>\n");
	printf("        <tr><td colspan=2>&nbsp;</td></tr>\n");
	printf("      </table>\n");
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("</table>\n\n");
	printf("</form>\n");

	m_pJkMemoMain->TailHtml();

	DBClose();
}

/**
 * Show Admin Save
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::AdminSave(void)
{
	char	szPath[0xff] = "";

	/**
	 * Get DB File
	*/
	sprintf(szPath, "./db/%s.gdbm", m_pJkMemoMain->GetDbName());

	DBOpen(szPath, GDBM_WRITER);

	m_pJkMemoMain->SetRefreshValue(2);
	m_pJkMemoMain->HeadHtml("ȯ漳 ");

	/**
	 * Compare passwd1 & passwd2
	*/
	if (strcmp(qValue("passwd1"), "") != 0 || strcmp(qValue("passwd2"), "") != 0)
	{
		if (strcmp(qValue("passwd1"), qValue("passwd2")) == 0)
		{
#if defined(UNIX)
			DBStore("SysConfig.pszPasswd", crypt(qValue("passwd1"), "jk"), GDBM_REPLACE);
#else
			DBStore("SysConfig.pszPasswd", jk_crypt(qValue("passwd1"), "jk"), GDBM_REPLACE);
#endif
		}
		else
		{
			qError(" ȣ Ʋϴ.");
		}
	}

	if (strcmp(qValue("ad") , "") != 0)
	{
		DBStore("SysConfig.pszAd", qValue("ad"), GDBM_REPLACE);
	}

	if (strcmp(qValue("width") , "") != 0)
	{
		DBStore("SysConfig.iWidth", qValue("width"), GDBM_REPLACE);
	}

	if (strcmp(qValue("ArticlePerPage"), "") != 0)
	{
		if (qiValue("ArticlePerPage") > 15)
		{
			qError("15  ʰҼ ϴ.");
		}

		DBiStore("SysConfig.iArticlePerPage", atoi(qValue("ArticlePerPage")), GDBM_REPLACE);
	}

	if (strcmp(qValue("posting"), "allow") == 0)
	{
		DBiStore("SysConfig.iIsPostAllow", ALLOW, GDBM_REPLACE);
	}
	else
	{
		DBiStore("SysConfig.iIsPostAllow", DENY, GDBM_REPLACE);
	}

	printf("<br><br><br><br><br><br><br><br>\n");
	printf("ȯ漳 Ǿϴ.<br>\n");
	printf("%dĿ óȭ ϴ.<br>\n", m_pJkMemoMain->GetRefreshValue());
	printf("<br><br><br><br><br>\n");
//	printf("<a href=\"javascript:self.close();\">[âݱ]</a>\n");
	m_pJkMemoMain->TailHtml();

	DBClose();

}

/**
 * Show Remove Form
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::RemoveForm(void)
{
	m_pJkMemoMain->SetRefreshValue(300);
	m_pJkMemoMain->HeadHtml("ۻϱ");

	printf("<script name='JavaScript'>\n");
	printf("  function checkForm()\n");
	printf("  {\n");
	printf("    var form = document.forms[0];\n");
	printf("    if (IsEmpty(form.passwd.value)) {\n");
	printf("      alert(\"ȣ Էؾ߸ մϴ.\");\n");
	printf("      form.passwd.focus();\n");
	printf("      return false;\n");
	printf("    }\n");
	printf("  }\n");
	printf("  function IsEmpty(val) {\n");
	printf("    for (var i=0; i<val.length; i++) {\n");
	printf("      if (val.substring(i,i+1) != \" \")\n");
	printf("        return false;\n");
	printf("    }\n");
	printf("    return true;\n");
	printf("  }\n");
	printf("</script>\n\n");
	
	printf("<br><br><br><br><br>\n");

	printf("<form method=post action='%s' onSubmit=\"return checkForm()\">\n", qCGIname());
	printf("<table border=0 cellpadding=1 cellspacing=0 bgcolor=black width='300'>\n");
	printf("  <tr>\n");
	printf("    <td>\n");
	printf("    <table border=0 cellpadding=1 cellspaciing=0 bgcolor=white width='100%%'>\n");
	printf("      <input type=hidden name=dbName value='%s'>\n", m_pJkMemoMain->GetDbName());
	printf("      <input type=hidden name=dbMode value='RemoveSave'>\n");
	printf("      <input type=hidden name=dbNum value='%d'>\n", m_pJkMemoMain->GetDbNum());
	printf("      <tr height=24 bgcolor=#2b3856>\n");
	printf("        <td colspan=2 align=middle><b><font size=3 color=white> </font></b></td>\n");
	printf("      </tr>\n");
	printf("      <tr><td colspan=2>&nbsp;</td></tr>\n");
	printf("      <tr>\n");
	printf("        <td align=center width=50%%> ȣ&nbsp;&nbsp;</td>\n");
	printf("        <td align=left>\n");
	printf("          <input type=password name=passwd size=10 maxlength=8 class=editbox>\n");
	printf("          <script language='JavaScript'>\n");
	printf("            <!--\n");
	printf("              document.forms[0].passwd.focus();\n");
	printf("            -->\n");
	printf("          </script>\n");
	printf("        </td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2>&nbsp;</td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2 align=middle>\n");
	printf("          <input type=submit value='            ' class=button>\n");
	printf("        </td>\n");
	printf("      </tr>\n");
	printf("      <tr>\n");
	printf("        <td colspan=2>&nbsp;</td>\n");
	printf("      </tr>\n");
	printf("    </table>\n");
	printf("    </td>\n");
	printf("  </tr>\n");
	printf("</table>\n");
	printf("</form>\n");

	m_pJkMemoMain->TailHtml();
}

/**
 * Remove Save
 *
 * Arg: void
 * Ret: none
*/
void JkMemoWrite::RemoveSave(void)
{
	char	szPath[0xff] = "";

	/**
	 * Get DB File
	*/
	sprintf(szPath, "./db/%s.gdbm", m_pJkMemoMain->GetDbName());

	DBOpen(szPath, GDBM_WRITER);

	m_pJkMemoMain->m_pSysConfig->pszPasswd = DBFetch("SysConfig.pszPasswd");

#if defined(UNIX)
	if (strcmp(crypt(qValue("passwd"), "jk"), m_pJkMemoMain->GetAdminPasswd()) != 0)
#else
	if (strcmp(jk_crypt(qValue("passwd"), "jk"), m_pJkMemoMain->GetAdminPasswd()) != 0)
#endif
	{
		qError("н尡 Ʋϴ.");
	}

	m_pJkMemoMain->SetRefreshValue(3);
	m_pJkMemoMain->HeadHtml("ۻ ");

	/**
	 * ̹  Խù ˻
	*/
	if (DBFetch("%d.iNum", m_pJkMemoMain->GetDbNum()) == NULL)
	{
		qError("Խù  ʽϴ.");
	}

	/**
	 * Խù 
	*/
	DBDelete("%d.iNum", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.iAccess", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.iThread", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszDate", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszTime", m_pJkMemoMain->GetDbNum());

	DBDelete("%d.pszName", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszEMail", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszPasswd", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszIpAdd", m_pJkMemoMain->GetDbNum());
	DBDelete("%d.pszIpAdd", m_pJkMemoMain->GetDbNum());

	printf("<br><br><br><br><br><br><br><br>\n");
	printf("Խù Ǿϴ.<br>\n");
	printf("%dĿ óȭ ϴ.<br>\n", m_pJkMemoMain->GetRefreshValue());

//	printf("<a href=\"javascript:self.close();\">[âݱ]</a>\n");
	m_pJkMemoMain->TailHtml();

	DBClose();
}

/**
 * Run().
 */
void JkMemoWrite::Run()
{
	if (!strcmp(m_pJkMemoMain->GetDbMode(), "Write"))
	{
		if (m_pJkMemoMain->IsPostAllow() == DENY)
		{
			qError("ڿ ؼ Ⱑ Ǿϴ.");
		}

		WriteSave();
		m_pJkMemoMain->RefreshList();
	}
	else if (!strcmp(m_pJkMemoMain->GetDbMode(), "Remove"))
	{
		RemoveForm();
	}
	else if (!strcmp(m_pJkMemoMain->GetDbMode(), "RemoveSave"))
	{
		RemoveSave();
		m_pJkMemoMain->RefreshList();
	}
	else if (!strcmp(m_pJkMemoMain->GetDbMode(), "AdminLogin"))
	{
		AdminLogin();
	}
	else if (!strcmp(m_pJkMemoMain->GetDbMode(), "AdminForm"))
	{
		AdminForm();
	}
	else if (!strcmp(m_pJkMemoMain->GetDbMode(), "AdminSave"))
	{
		AdminSave();
	}
}
